module Alunos where

data Aluno = A String Int Float Float
  deriving Eq

numero (A _ n _ _) = n

instance Show Aluno where
  show (A no nu p t)  = (take 8 ((show nu) ++ espacos)) 
                     ++ (take 36 (no ++ espacos)) 
                     ++ (take 8 ((show p) ++ espacos))
                     ++ (take 8 ((show t) ++ espacos))
                     ++ (resultado p t)
  showList l = showString (unlines (map show l))

espacos = ' ':espacos

resultado p t = if (p < 10) || (t < 8) then "Rep"
                else (show (round (0.6 * t + 0.4 * p)))


instance Ord Aluno where
  compare (A _ x _ _) (A _ y _ _) = compare x y

a1 = A "Joao" 23456 3.5 5.6   ---- para experimentar

readAluno s = let (nu:resto) = words s
                  (no,p,t) = separa resto
                  separa [x,y,z] = ([],x,y)
                  separa (h:t) = let (a,b,c) = separa t
                                 in (h:a, b, c)
              in (A  (unwords no) (read nu) (read p) (read t))

-- definio alternativa 

readAluno' s = let (nu:resto) = words s
                   (_:t:p:r) = reverse resto
                in (A  (unwords (reverse r)) (read nu) (read p) (read t))


instance Read Aluno where
   readsPrec _ s = [(readAluno s,"")]


