module Main where

import IO
import Alunos
import BSTree


main = do { hSetBuffering stdout NoBuffering
          ; ciclo Vazia
          }


ciclo :: BSTree Aluno -> IO ()
ciclo a = do { o <- menu 
             ;  case o of
                '1':_ -> do { a' <- insereAluno a 
                            ; ciclo a'
                            }
                '2':_ -> do { listaAlunos a
                            ; ciclo a
                            }
                '3':_ -> do { procuraAluno a
                            ; ciclo a
                            }
                '4':_ -> do { guarda a 
                            ; ciclo a 
                            }
                '5':_ -> do { a' <- leInfo a
                            ; ciclo a'
                            }
                '0':_ -> return ()
                otherwise -> do { putStrLn "Opcao invalida"
                                ; ciclo a
                                } 
             }

menu :: IO String
menu = do { putStrLn menutxt 
          ; putStr "Opcao: "
          ; c <- getLine 
          ; return c
          }
    where menutxt = unlines ["", 
                             "Inserir Aluno .......  1",
                             "Listar Alunos .......  2",
                             "Procurar Aluno ......  3",
                             "Guardar informacao ..  4",
                             "Ler informacao ......  5",
                             "",
                             "Sair ................  0"]
                     
insereAluno :: BSTree Aluno -> IO (BSTree Aluno)
insereAluno a 
  = do { putStr "\nNumero: "; nu <- getLine
       ; putStr "Nome: "; no <- getLine
       ; putStr "Nota Pratica: " ; p <- getLine
       ; putStr "Nota Teorica: "; t <- getLine
       ; return (insere a (A no (read nu) (read p) (read t)))
       }

-- listaAlunos _ = return () --- para completar
listaAlunos a = do { putStrLn "\nLista dos alunos"
                   ; putStrLn "\n-------------------------\n"
                   ; print (inorder a)
                   ; putStrLn "\n-------------------------\n"
                   }

-- procuraAluno _ = return () --- para completar
procuraAluno a = do { putStr "\nNumero do aluno: "
                    ; n <- getLine
                    ; putStrLn "\n-------------------------\n"
                    ; case pesquisaNumAluno a (read n) of
                        Just x -> print x
                        Nothing -> putStrLn "Aluno nao encontrado" 
                    ; putStrLn "\n-------------------------\n"
                    }

pesquisaNumAluno Vazia x = Nothing
pesquisaNumAluno (Nodo r e d) x 
    | x < (numero r) = pesquisaNumAluno e x
    | x > (numero r) = pesquisaNumAluno d x
    | otherwise      = Just r

-- guarda _ = return () --- para completar
guarda a = do { putStr "\nNome do ficheiro: "
              ; fn <- getLine
              ; putStr "\n----------"
              ; tentativa <- try (writeFile fn (show (inorder a)))
              ; case tentativa of
                  Right _ -> putStrLn "---------------\n"
                  _       -> putStrLn "  ERRO --------\n"
              }

-- leInfo = return Vazia --- para completar
leInfo a = do { putStr "\nNome do ficheiro: "
              ; fn <- getLine
              ; putStr "\n----------"
              ; tentativa <- try (readFile fn)
              ; case tentativa of 
                  Left _ -> do { putStrLn "  ERRO --------\n"
                               ; return a
                               }
                  Right c -> do { putStrLn "---------------\n"
                                ; return (invInorder (map read (lines c)))
                                }
              }
